*filter
# Allow all outgoing, but drop incoming and forwarding packets by default
:INPUT DROP [0:0]
:FORWARD DROP [0:0]
:OUTPUT ACCEPT [0:0]

# Custom per-protocol chains
:UDP - [0:0]
:TCP - [0:0]
:ICMP - [0:0]

# Accept all traffic on trusted interfaces allready estrablished connections
-A INPUT -m conntrack --ctstate ESTABLISHED,RELATED -j ACCEPT
{% for interface in trusted_interfaces %}
-A INPUT -i {{ interface }} -j ACCEPT
{% endfor %}

# Drop invalid packets
-A INPUT -m conntrack --ctstate INVALID -j DROP

# Pass traffic to protocol-specific chains
## Only allow new connections (established and related should already be handled)
## For TCP, additionally only allow new SYN packets since that is the only valid
## method for establishing a new TCP connection
-A INPUT -p udp -m conntrack --ctstate NEW -j UDP
-A INPUT -p tcp --syn -m conntrack --ctstate NEW -j TCP
-A INPUT -p icmp -m conntrack --ctstate NEW -j ICMP

# Accept specific rules
{% for rule in host_v4_rules %}
-A {{ rule.group | default('INPUT') }} -p {{ rule.protocol }} {{ '--dport ' + (rule.dport|string) if rule.dport is defined }} {{ '-d ' + (rule.destination|string) if rule.destination is defined }} {{ '-s ' + (rule.source|string) if rule.source is defined }} {{ '-m conntrack --ctstate ' + rule.conntrack if rule.conntrack is defined }} -j {{ rule.target }} {{ '-m comment --comment "' + rule.comment +'"' if rule.comment is defined }}
{% endfor %}

# Reject anything that's fallen through to this point
## Try to be protocol-specific w/ rejection message
-A INPUT -p udp -j REJECT --reject-with icmp-port-unreachable
-A INPUT -p tcp -j REJECT --reject-with tcp-reset
-A INPUT -j REJECT --reject-with icmp-proto-unreachable

# Commit the changes
COMMIT

*raw
:PREROUTING ACCEPT [0:0]
:OUTPUT ACCEPT [0:0]
COMMIT

*nat
:PREROUTING ACCEPT [0:0]
:INPUT ACCEPT [0:0]
:OUTPUT ACCEPT [0:0]
:POSTROUTING ACCEPT [0:0]
COMMIT

*security
:INPUT ACCEPT [0:0]
:FORWARD ACCEPT [0:0]
:OUTPUT ACCEPT [0:0]
COMMIT

*mangle
:PREROUTING ACCEPT [0:0]
:INPUT ACCEPT [0:0]
:FORWARD ACCEPT [0:0]
:OUTPUT ACCEPT [0:0]
:POSTROUTING ACCEPT [0:0]
COMMIT
